#![feature(proc_macro_quote)]
#![no_std]

use core::str::FromStr;

extern crate alloc;

use alloc::string::ToString;
use proc_macro::{quote, TokenStream};
use syn::parse;

#[proc_macro]
pub fn impl_static_pin(pin: TokenStream) -> TokenStream {
    let parsing_result = parse::<syn::Ident>(pin.clone());

    if let Ok(ident) = parsing_result {
        let pin = TokenStream::from_str(ident.to_string().as_str()).unwrap();
        let mut identifier = ident.to_string();
        identifier.insert_str(1, "ORT");

        let pin_num = identifier.pop().unwrap();

        if pin_num.is_ascii_digit() {
            let pin_num = TokenStream::from_str(&pin_num.to_string()).unwrap();

            let port_field = TokenStream::from_str(&identifier.to_ascii_lowercase()).unwrap();

            let port_ident = TokenStream::from_str(identifier.as_str()).unwrap();
            let trait_ident = TokenStream::from_str("StaticPin").unwrap();

            quote! {
                impl $trait_ident for $pin {
                    type Port = $port_ident;
                    const PIN_NUM: u8 = $pin_num;

                    fn write(data: u8) {
                        unsafe {
                            (*Self::Port::ptr())
                                .$port_field
                                .write(|w| w.bits(data));
                        }
                    }
                    fn read() -> u8 {
                        unsafe { (*Self::Port::ptr()).$port_field.read().bits() }
                    }
                }
            }
        } else {
            unreachable!()
        }
    } else {
        unreachable!()
    }
}
